"use strict";

this.name      = "ncc_carrier"; 
this.author    = "spara"; 
this.copyright = "2014 Mika Spåra, Eric Walch";
this.description = "ship script for navy class carrier";
this.licence     = "CC BY-NC-SA 3.0";

this.shipSpawned = function () {
	this.ship.displayName = this.ship.name + ": " + this.ship.scriptInfo.name;
	this.$scanTimer = new Timer(this, this.$scanForThargons, 0, 10);
}

this.$collectors = 3;

this.$scanForThargons = function () {
    function $isDeadThargon(entity)
    {
		if ((entity.hasRole("tharglet") || entity.hasRole("thargon")) && entity.isCargo) {
			return true;
		}
		return false;
    };
	if (this.$collectors > 0) {
		if (ship.AI === "nccCarrierInterceptAI.plist" && ship.AIState !== "ATTACK_SHIP") {
			if (system.filteredEntities(this, $isDeadThargon, ship, 25600).length > 0) {
				ship.launchShipWithRole("ncc-thargon-collector");
				this.$collectors--;
			}
		}
	}
};

this.otherShipDocked = function(whom)
{
     if (whom.hasRole("ncc-thargon-collector")) this.$collectors++;
}

//the rest is from behemoth-carrier.js script from behemoth oxp.

this.shipTargetCloaked = function ()
{
    this.cloakedTarget = this.ship.target;
    if(this.cloakingTimer) this.cloakingTimer.start()
    else this.cloakingTimer = new Timer(this, this.statusCheck, 1, 1);
};

this.statusCheck = function ()
{
    if (!this.ship || !this.ship.isValid) this.cloakingTimer.stop();
    if (this.cloakedTarget) 
    { 
        if (this.cloakedTarget.isCloaked) return;
        else 
        { 
            this.ship.target = this.cloakedTarget; 
            this.ship.reactToAIMessage("TARGET_DECLOAKED"); 
        } 
    } 
    if (this.cloakingTimer) 
    { 
        this.cloakingTimer.stop(); 
        delete this.cloakingTimer; 
    } 
};

this.playerWillEnterWitchspace = this.shipDied = function ()
{
    if (this.cloakingTimer) {this.cloakingTimer.stop(); delete this.cloakingTimer}
};

this.shipBeingAttackedByCloaked = function ()
{
	function isCloaked(entity) {
		return (entity.isShip && entity.isCloaked);
	};
    if (!this.cloakedTarget) {
        this.cloakedTarget = system.filteredEntities(this, isCloaked, this.ship)[0];
    };
    if (this.cloakedTarget && this.cloakedTarget.isCloaked)
    {
        if (this.cloakingTimer) this.cloakingTimer.start()
        else this.cloakingTimer = new Timer(this, this.statusCheck, 1, 1);
    };
};

this.shipBeingAttacked = this.offenceCommittedNearby = function (who)
{
	if (this.ship.target && this.ship.target != who && (who.bounty * who.maxEnergy > this.ship.target.bounty * this.ship.target.maxEnergy || who.isPlayer) && who.scanClass !== "CLASS_POLICE")
    {
         this.ship.reactToAIMessage("SWITCH_TARGET");
         this.ship.target = who;
    }
};

